#ifndef _ACMP_CLIENT_H
#define _ACMP_CLIENT_H 1

#include <functional>
#include <mutex>
#include <string>
#include <thread>
#include <vector>

class ACMPClient {
public:
	ACMPClient(const std::string &host, int port);

	void add_init_command(const std::string &cmd);
	void start();
	void end();
	void send_command(const std::string &cmd);  // Thread-safe.
	void change_server(const std::string &host, int port);  // Thread-safe.
	void set_connection_callback(const std::function<void(bool)> &callback);

private:
	void thread_func();

	std::thread t;
	std::vector<std::string> init_commands;
	std::function<void(bool)> connection_callback;

	std::mutex mu;
	std::string host;  // Protected by mu.
	int port;  // Protected by mu.
	std::vector<std::string> queued_commands;  // Protected by mu.
};

#endif  // !defined(_ACMP_CLIENT_H)
