'use strict';

function load_roster(sheet, cb)
{
	let req = new XMLHttpRequest();
	req.onload = function(e) {
		let response = JSON.parse(req.responseText);

		let team_name = '';
		if (response.values[0].length >= 1 &&
		    response.values[0][0] !== undefined &&
		    response.values[0][0] !== null) {
			team_name = response.values[0][0];
		}

		let roster = [];
		let i;
		for (i = 0; i < response.values.length; ++i) {
			if (response.values[i][0] === 'Number') {
				++i;
				break;
			}
		}

		for ( ; response.values[i] !== undefined && response.values[i].length >= 3; ++i) {
			let display_number = response.values[i][1];
			let name = response.values[i][2];
			roster.push({
				"number": display_number,
				"name": name
			});
		}
		cb(team_name, roster);
	};
	req.open('GET', 'https://sheets.googleapis.com/v4/spreadsheets/1RciMlauWxqM9LYKdsY6lPjJbIAcHJpCXTqyZSEHxH3U/values/\'' + sheet + '\'!A1:J50?key=AIzaSyAuP9yQn8g0bSay6r_RpGtpFeIbwprH1TU');
	req.send();
};

function display_roster(team_name, roster)
{
	document.getElementById('entire-bug').style.display = 'none';

	let carousel = document.getElementById('carousel');
	clear_carousel(carousel);

	if (team_name === '') {
		addheading(carousel, 4, 'Team lineup');
	} else {
		addheading(carousel, 4, 'Team lineup<br />' + team_name);
	}

	for (let i = 0; i < roster.length; i += 2) {
		let tr = document.createElement("tr");

		addth(tr, "playernum", roster[i].number);
		addtd(tr, "playername", roster[i].name);

		if (i + 1 < roster.length) {
			addth(tr, "playernum", roster[i + 1].number);
			addtd(tr, "playername", roster[i + 1].name);
		} else {
			addth(tr, "playernum", "");
			addtd(tr, "playername", "");
		}
		carousel.appendChild(tr);
	}
	fade_in_rows(carousel);

	carousel.style.display = 'table';
}

function showroster(sheet)
{
	load_roster(sheet, display_roster);
}

function showroster_from_state()
{
	showroster(state['team_code']);
}

function showrostercarousel(sheet1, sheet2)
{
	let team_names = [null, null];
	let rosters = [null, null];
	let num_left = 2;

	let cb = function(id, team_name, roster) {
		team_names[id] = team_name;
		rosters[id] = roster;
		if (--num_left == 0) {
			do_series([
				[ 13000, function() { display_roster(team_names[0], rosters[0]); } ],
				[ 2000, function() { hidetable(); } ],
				[ 13000, function() { display_roster(team_names[1], rosters[1]); } ],
				[ 2000, function() { hidetable(); } ]
			]);
		}
	};

	load_roster(sheet1, function(team_name, roster) { cb(0, team_name, roster); });
	load_roster(sheet2, function(team_name, roster) { cb(1, team_name, roster); });
}

function showrostercarousel_from_state()
{
	showrostercarousel(state['team1'], state['team2']);
}
